﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace WindowsFormsApplication13
{
	public class MyMaskeditBox : RadDateTimePicker, INotifyPropertyChanged
	{
		DateTime? _value;
		private static readonly object ValueChangedKey = new object();

		public new event EventHandler ValueChanged
		{
			add
			{
				base.Events.AddHandler(ValueChangedKey, value);
			}
			remove
			{
				base.Events.RemoveHandler(ValueChangedKey, value);
			}
		}

		public new DateTime? Value
		{
			get
			{
				if (_value.HasValue)
				{
					return base.Value;
				}

				return null;
			}
			set
			{
				_value = value;
				if (value == null)
				{
					base.Value = base.NullDate;
					this.SetToNullValue();
				}
				else
				{
					base.Value = value.Value;
				}

				OnValueChanged(new EventArgs());
				OnNotifyPropertyChanged("Value");
			}
		}

		protected override void OnValueChanged(EventArgs e)
		{
			base.OnValueChanged(e);
			EventHandler valueChanged = (EventHandler)base.Events[ValueChangedKey];
			if (valueChanged != null)
			{
				valueChanged(this, e);
			}
		}
	}

	public class MyObject : INotifyPropertyChanged
	{
		DateTime? num;

		public DateTime? Num
		{
			get
			{
				return num;
			}
			set
			{
				MessageBox.Show("Num Set is called");
				num = value;
				if (PropertyChanged != null)
				{
					PropertyChanged(this, new PropertyChangedEventArgs("Num"));
				}
			}
		}

		public event PropertyChangedEventHandler PropertyChanged;
	}

	public partial class Form1 : Form
	{
		MyObject myObject = new MyObject();

		public Form1()
		{
			InitializeComponent();				
		}

		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);
			this.radMaskedEditBox1.DataBindings.Add("Value", myObject, "Num", true, DataSourceUpdateMode.OnPropertyChanged);
		}

		protected override void OnClick(EventArgs e)
		{
			base.OnClick(e);
			myObject.Num = null;
		}
	}
}